module jp.ku6.windows.directx.d2derr;

import jp.ku6.windows.win32api.windef;
import jp.ku6.windows.win32api.winerror;
import jp.ku6.windows.win32api.wincodec;

immutable ushort FACILITY_D2D = 0x899;

template MAKE_D2DHR(ushort sev, ushort code)
{
	immutable HRESULT MAKE_D2DHR = MAKE_HRESULT!(sev, FACILITY_D2D, code);
}

template MAKE_D2DHR_ERR(ushort code)
{
	immutable MAKE_D2DHR_ERR = MAKE_D2DHR!(1, code);
}

immutable HRESULT D2DERR_UNSUPPORTED_PIXEL_FORMAT = WINCODEC_ERR_UNSUPPORTEDPIXELFORMAT;
immutable HRESULT D2DERR_INSUFFICIENT_BUFFER = HRESULT_FROM_WIN32!(ERROR_INSUFFICIENT_BUFFER);

immutable HRESULT D2DERR_WRONG_STATE                         = MAKE_D2DHR_ERR!(0x001);
immutable HRESULT D2DERR_NOT_INITIALIZED                     = MAKE_D2DHR_ERR!(0x002);
immutable HRESULT D2DERR_UNSUPPORTED_OPERATION               = MAKE_D2DHR_ERR!(0x003);
immutable HRESULT D2DERR_SCANNER_FAILED                      = MAKE_D2DHR_ERR!(0x004);
immutable HRESULT D2DERR_SCREEN_ACCESS_DENIED                = MAKE_D2DHR_ERR!(0x005);
immutable HRESULT D2DERR_DISPLAY_STATE_INVALID               = MAKE_D2DHR_ERR!(0x006);
immutable HRESULT D2DERR_ZERO_VECTOR                         = MAKE_D2DHR_ERR!(0x007);
immutable HRESULT D2DERR_INTERNAL_ERROR                      = MAKE_D2DHR_ERR!(0x008);
immutable HRESULT D2DERR_DISPLAY_FORMAT_NOT_SUPPORTED        = MAKE_D2DHR_ERR!(0x009);
immutable HRESULT D2DERR_INVALID_CALL                        = MAKE_D2DHR_ERR!(0x00A);
immutable HRESULT D2DERR_NO_HARDWARE_DEVICE                  = MAKE_D2DHR_ERR!(0x00B);
immutable HRESULT D2DERR_RECREATE_TARGET                     = MAKE_D2DHR_ERR!(0x00C);
immutable HRESULT D2DERR_TOO_MANY_SHADER_ELEMENTS            = MAKE_D2DHR_ERR!(0x00D);
immutable HRESULT D2DERR_SHADER_COMPILE_FAILED               = MAKE_D2DHR_ERR!(0x00E);
immutable HRESULT D2DERR_MAX_TEXTURE_SIZE_EXCEEDED           = MAKE_D2DHR_ERR!(0x00F);
immutable HRESULT D2DERR_UNSUPPORTED_VERSION                 = MAKE_D2DHR_ERR!(0x010);
immutable HRESULT D2DERR_BAD_NUMBER                          = MAKE_D2DHR_ERR!(0x011);
immutable HRESULT D2DERR_WRONG_FACTORY                       = MAKE_D2DHR_ERR!(0x012);
immutable HRESULT D2DERR_LAYER_ALREADY_IN_USE                = MAKE_D2DHR_ERR!(0x013);
immutable HRESULT D2DERR_POP_CALL_DID_NOT_MATCH_PUSH         = MAKE_D2DHR_ERR!(0x014);
immutable HRESULT D2DERR_WRONG_RESOURCE_DOMAIN               = MAKE_D2DHR_ERR!(0x015);
immutable HRESULT D2DERR_PUSH_POP_UNBALANCED                 = MAKE_D2DHR_ERR!(0x016);
immutable HRESULT D2DERR_RENDER_TARGET_HAS_LAYER_OR_CLIPRECT = MAKE_D2DHR_ERR!(0x017);
immutable HRESULT D2DERR_INCOMPATIBLE_BRUSH_TYPES            = MAKE_D2DHR_ERR!(0x018);
immutable HRESULT D2DERR_WIN32_ERROR                         = MAKE_D2DHR_ERR!(0x019);
immutable HRESULT D2DERR_TARGET_NOT_GDI_COMPATIBLE           = MAKE_D2DHR_ERR!(0x01A);
immutable HRESULT D2DERR_TEXT_EFFECT_IS_WRONG_TYPE           = MAKE_D2DHR_ERR!(0x01B);
immutable HRESULT D2DERR_TEXT_RENDERER_NOT_RELEASED          = MAKE_D2DHR_ERR!(0x01C);
immutable HRESULT D2DERR_EXCEEDS_MAX_BITMAP_SIZE             = MAKE_D2DHR_ERR!(0x01D);

