module jp.ku6.windows.win32api.structuredquerycondition;

import jp.ku6.windows.win32api.basetyps;
import jp.ku6.windows.win32api.wtypes;
import jp.ku6.windows.win32api.windef;
import jp.ku6.windows.win32api.unknwn;
import jp.ku6.windows.win32api.rpcdcep;
import jp.ku6.windows.win32api.propidl;
import jp.ku6.windows.win32api.objidl;

extern (Windows):

enum CONDITION_TYPE
{
	CT_AND_CONDITION,
	CT_OR_CONDITION,
	CT_NOT_CONDITION,
	CT_LEAF_CONDITION,
}

enum CONDITION_OPERATION
{
	COP_IMPLICIT,
	COP_EQUAL,
	COP_NOTEQUAL,
	COP_LESSTHAN,
	COP_GREATERTHAN,
	COP_LESSTHANOREQUAL,
	COP_GREATERTHANOREQUAL,
	COP_VALUE_STARTSWITH,
	COP_VALUE_ENDSWITH,
	COP_VALUE_CONTAINS,
	COP_VALUE_NOTCONTAINS,
	COP_DOSWILDCARDS,
	COP_WORD_EQUAL,
	COP_WORD_STARTSWITH,
	COP_APPLICATION_SPECIFIC,
}

immutable IID IID_IRichChunk = {0x4FDEF69C, 0xDBC9, 0x454e, [0x99, 0x10, 0xB3, 0x4F, 0x3C, 0x64, 0xB5, 0x10]};
interface IRichChunk : IUnknown
{
	HRESULT GetData(ULONG* pFirstPos, ULONG* pLength, LPWSTR* ppsz, PROPVARIANT* pValue);
}

HRESULT IRichChunk_RemoteGetData_Proxy(IRichChunk This, ULONG* pFirstPos, ULONG* pLength, LPWSTR* ppsz, PROPVARIANT* pValue);
void IRichChunk_RemoteGetData_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_ICondition = {0x0FC988D4, 0xC935, 0x4b97, [0xA9, 0x73, 0x46, 0x28, 0x2E, 0xA1, 0x75, 0xC8]};
interface ICondition : IPersistStream
{
	HRESULT GetConditionType(CONDITION_TYPE* pNodeType);
	HRESULT GetSubConditions(REFIID riid, void** ppv);
	HRESULT GetComparisonInfo(LPWSTR* ppszPropertyName, CONDITION_OPERATION* pcop, PROPVARIANT* ppropvar);
	HRESULT GetValueType(LPWSTR* ppszValueTypeName);
	HRESULT GetValueNormalization(LPWSTR* ppszNormalization);
	HRESULT GetInputTerms(IRichChunk* ppPropertyTerm, IRichChunk* ppOperationTerm, IRichChunk* ppValueTerm);
	HRESULT Clone(ICondition* ppc);
}

HRESULT ICondition_RemoteGetComparisonInfo_Proxy(ICondition This, LPWSTR* ppszPropertyName, CONDITION_OPERATION* pcop, PROPVARIANT* ppropvar);
void ICondition_RemoteGetComparisonInfo_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT ICondition_RemoteGetInputTerms_Proxy(ICondition This, IRichChunk* ppPropertyTerm, IRichChunk* ppOperationTerm, IRichChunk* ppValueTerm);
void ICondition_RemoteGetInputTerms_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_ICondition2 = {0x0DB8851D, 0x2E5B, 0x47eb, [0x92, 0x08, 0xD2, 0x8C, 0x32, 0x5A, 0x01, 0xD7]};
interface ICondition2 : ICondition
{
	HRESULT GetLocale(LPWSTR* ppszLocaleName);
	HRESULT GetLeafConditionInfo(PROPERTYKEY* ppropkey, CONDITION_OPERATION* pcop, PROPVARIANT* ppropvar);
}

HRESULT ICondition2_RemoteGetLeafConditionInfo_Proxy(ICondition2 This, PROPERTYKEY* ppropkey, CONDITION_OPERATION* pcop, PROPVARIANT* ppropvar);
void ICondition2_RemoteGetLeafConditionInfo_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

alias jp.ku6.windows.win32api.propidl.BSTR_UserSize BSTR_UserSize;
alias jp.ku6.windows.win32api.propidl.BSTR_UserMarshal BSTR_UserMarshal;
alias jp.ku6.windows.win32api.propidl.BSTR_UserUnmarshal BSTR_UserMarshal;
alias jp.ku6.windows.win32api.propidl.BSTR_UserFree BSTR_UserFree;

alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserSize LPSAFEARRAY_UserSize;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserMarshal LPSAFEARRAY_UserMarshal;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserUnmarshal LPSAFEARRAY_UserUnmarshal;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserFree LPSAFEARRAY_UserFree;

HRESULT IRichChunk_GetData_Proxy(IRichChunk This, ULONG* pFirstPos, ULONG* pLength, LPWSTR* ppsz, PROPVARIANT* pValue);
HRESULT IRichChunk_GetData_Stub(IRichChunk This, ULONG* pFirstPos, ULONG* pLength, LPWSTR* ppsz, PROPVARIANT* pValue);
HRESULT ICondition_GetComparisonInfo_Proxy(ICondition This, LPWSTR* ppszPropertyName, CONDITION_OPERATION* pcop, PROPVARIANT* ppropvar);
HRESULT ICondition_GetComparisonInfo_Stub(ICondition This, LPWSTR* ppszPropertyName, CONDITION_OPERATION* pcop, PROPVARIANT* ppropvar);
HRESULT ICondition_GetInputTerms_Proxy(ICondition This, IRichChunk* ppPropertyTerm, IRichChunk* ppOperationTerm, IRichChunk* ppValueTerm);
HRESULT ICondition_GetInputTerms_Stub(ICondition This, IRichChunk* ppPropertyTerm, IRichChunk* ppOperationTerm, IRichChunk* ppValueTerm);
HRESULT ICondition2_GetLeafConditionInfo_Proxy(ICondition2 This, PROPERTYKEY* ppropkey, CONDITION_OPERATION* pcop, PROPVARIANT* ppropvar);
HRESULT ICondition2_GetLeafConditionInfo_Stub(ICondition2 This, PROPERTYKEY* ppropkey, CONDITION_OPERATION* pcop, PROPVARIANT* ppropvar);

