module jp.ku6.windows.win32api.wincodec;

import jp.ku6.windows.win32api.windef;
import jp.ku6.windows.win32api.basetyps;
import jp.ku6.windows.win32api.unknwn;
import jp.ku6.windows.win32api.objidl;
import jp.ku6.windows.win32api.ocidl;
import jp.ku6.windows.win32api.propidl;

alias UINT32 WICColor;
alias REFGUID REFWICPixelFormatGUID;
alias GUID WICPixelFormatGUID;

struct WICRect
{
	INT X;
	INT Y;
	INT Width;
	INT Height;
}

enum WICColorContextType
{
	WICColorContextUninitialized  = 0,
	WICColorContextProfile        = 0x1,
	WICColorContextExifColorSpace = 0x2
}

enum WICBitmapCreateCacheOption
{
	WICBitmapNoCache                       = 0,
	WICBitmapCacheOnDemand                 = 0x1,
	WICBitmapCacheOnLoad                   = 0x2,
	WICBITMAPCREATECACHEOPTION_FORCE_DWORD = 0x7fffffff
}

enum WICDecodeOptions
{
	WICDecodeMetadataCacheOnDemand     = 0,
	WICDecodeMetadataCacheOnLoad       = 0x1,
	WICMETADATACACHEOPTION_FORCE_DWORD = 0x7fffffff
}

enum WICBitmapEncoderCacheOption
{
	WICBitmapEncoderCacheInMemory           = 0,
	WICBitmapEncoderCacheTempFile           = 0x1,
	WICBitmapEncoderNoCache                 = 0x2,
	WICBITMAPENCODERCACHEOPTION_FORCE_DWORD = 0x7fffffff
}

enum WICComponentType
{
	WICDecoder                   = 0x1,
	WICEncoder                   = 0x2,
	WICPixelFormatConverter      = 0x4,
	WICMetadataReader            = 0x8,
	WICMetadataWriter            = 0x10,
	WICPixelFormat               = 0x20,
	WICAllComponents             = 0x3f,
	WICCOMPONENTTYPE_FORCE_DWORD = 0x7fffffff
}

enum WICComponentEnumerateOptions
{
	WICComponentEnumerateDefault             = 0,
	WICComponentEnumerateRefresh             = 0x1,
	WICComponentEnumerateDisabled            = 0x80000000,
	WICComponentEnumerateUnsigned            = 0x40000000,
	WICCOMPONENTENUMERATEOPTIONS_FORCE_DWORD = 0x7fffffff
}

struct WICBitmapPattern
{
	ULARGE_INTEGER Position;
	ULONG Length;
	BYTE* Pattern;
	BYTE* Mask;
	BOOL EndOfStream;
}

enum WICBitmapInterpolationMode
{
	WICBitmapInterpolationModeNearestNeighbor = 0,
	WICBitmapInterpolationModeLinear          = 0x1,
	WICBitmapInterpolationModeCubic           = 0x2,
	WICBitmapInterpolationModeFant            = 0x3,
	WICBITMAPINTERPOLATIONMODE_FORCE_DWORD    = 0x7fffffff
}

enum WICBitmapPaletteType
{
	WICBitmapPaletteTypeCustom           = 0,
	WICBitmapPaletteTypeMedianCut        = 0x1,
	WICBitmapPaletteTypeFixedBW          = 0x2,
	WICBitmapPaletteTypeFixedHalftone8   = 0x3,
	WICBitmapPaletteTypeFixedHalftone27  = 0x4,
	WICBitmapPaletteTypeFixedHalftone64  = 0x5,
	WICBitmapPaletteTypeFixedHalftone125 = 0x6,
	WICBitmapPaletteTypeFixedHalftone216 = 0x7,
	WICBitmapPaletteTypeFixedWebPalette  = WICBitmapPaletteTypeFixedHalftone216,
	WICBitmapPaletteTypeFixedHalftone252 = 0x8,
	WICBitmapPaletteTypeFixedHalftone256 = 0x9,
	WICBitmapPaletteTypeFixedGray4       = 0xa,
	WICBitmapPaletteTypeFixedGray16      = 0xb,
	WICBitmapPaletteTypeFixedGray256     = 0xc,
	WICBITMAPPALETTETYPE_FORCE_DWORD = 0x7fffffff
}

enum WICBitmapDitherType
{
	WICBitmapDitherTypeNone           = 0,
	WICBitmapDitherTypeSolid          = 0,
	WICBitmapDitherTypeOrdered4x4     = 0x1,
	WICBitmapDitherTypeOrdered8x8     = 0x2,
	WICBitmapDitherTypeOrdered16x16   = 0x3,
	WICBitmapDitherTypeSpiral4x4      = 0x4,
	WICBitmapDitherTypeSpiral8x8      = 0x5,
	WICBitmapDitherTypeDualSpiral4x4  = 0x6,
	WICBitmapDitherTypeDualSpiral8x8  = 0x7,
	WICBitmapDitherTypeErrorDiffusion = 0x8,
	WICBITMAPDITHERTYPE_FORCE_DWORD   = 0x7fffffff
}

enum WICBitmapAlphaChannelOption
{
	WICBitmapUseAlpha                        = 0,
	WICBitmapUsePremultipliedAlpha           = 0x1,
	WICBitmapIgnoreAlpha                     = 0x2,
	WICBITMAPALPHACHANNELOPTIONS_FORCE_DWORD = 0x7fffffff
}

enum WICBitmapTransformOptions
{
	WICBitmapTransformRotate0             = 0,
	WICBitmapTransformRotate90            = 0x1,
	WICBitmapTransformRotate180           = 0x2,
	WICBitmapTransformRotate270           = 0x3,
	WICBitmapTransformFlipHorizontal      = 0x8,
	WICBitmapTransformFlipVertical        = 0x10,
	WICBITMAPTRANSFORMOPTIONS_FORCE_DWORD = 0x7fffffff
}

enum WICBitmapLockFlags
{
	WICBitmapLockRead              = 0x1,
	WICBitmapLockWrite             = 0x2,
	WICBITMAPLOCKFLAGS_FORCE_DWORD = 0x7fffffff
}

enum WICBitmapDecoderCapabilities
{
	WICBitmapDecoderCapabilitySameEncoder          = 0x1,
	WICBitmapDecoderCapabilityCanDecodeAllImages   = 0x2,
	WICBitmapDecoderCapabilityCanDecodeSomeImages  = 0x4,
	WICBitmapDecoderCapabilityCanEnumerateMetadata = 0x8,
	WICBitmapDecoderCapabilityCanDecodeThumbnail   = 0x10,
	WICBITMAPDECODERCAPABILITIES_FORCE_DWORD       = 0x7fffffff
}

enum WICProgressOperation
{
	WICProgressOperationCopyPixels   = 0x1,
	WICProgressOperationWritePixels  = 0x2,
	WICProgressOperationAll          = 0xffff,
	WICPROGRESSOPERATION_FORCE_DWORD = 0x7fffffff
}

enum WICProgressNotification
{
	WICProgressNotificationBegin        = 0x10000,
	WICProgressNotificationEnd          = 0x20000,
	WICProgressNotificationFrequent     = 0x40000,
	WICProgressNotificationAll          = 0xffff0000,
	WICPROGRESSNOTIFICATION_FORCE_DWORD = 0x7fffffff
}

enum WICComponentSigning
{
	WICComponentSigned              = 0x1,
	WICComponentUnsigned            = 0x2,
	WICComponentSafe                = 0x4,
	WICComponentDisabled            = 0x80000000,
	WICCOMPONENTSIGNING_FORCE_DWORD = 0x7fffffff
}


extern (Windows)
{
	interface IWICPalette : IUnknown
	{
		HRESULT InitializePredefined(WICBitmapPaletteType ePaletteType, BOOL fAddTransparentColor);
		HRESULT InitializeCustom(WICColor* pColors, UINT cCount);
		HRESULT InitializeFromBitmap(IWICBitmapSource pISurface, UINT cCount, BOOL fAddTransparentColor);
		HRESULT InitializeFromPalette(IWICPalette pIPalette);
		HRESULT GetType(WICBitmapPaletteType* pePaletteType);
		HRESULT GetColorCount(UINT* pcCount);
		HRESULT GetColors(UINT cCount, WICColor* pColors, UINT* pcActualColors);
		HRESULT IsBlackWhite(BOOL* pfIsBlackWhite);
		HRESULT IsGrayscale(BOOL* pfIsGrayscale);
		HRESULT HasAlpha(BOOL* pfHasAlpha);
	}

	interface IWICBitmapSource : IUnknown
	{
		HRESULT GetSize(UINT* puiWidth, UINT* puiHeight);
		HRESULT GetPixelFormat(WICPixelFormatGUID* pPixelFormat);
		HRESULT GetResolution(double* pDpiX, double* pDpiY);
		HRESULT CopyPalette(IWICPalette pIPalette);
		HRESULT CopyPixels(const(WICRect)* prc, UINT cbStride, UINT cbBufferSize, BYTE* pbBuffer);
	}

	interface IWICFormatConverter : IWICBitmapSource
	{
		HRESULT Initialize(IWICBitmapSource pISource, REFWICPixelFormatGUID dstFormat, WICBitmapDitherType dither, IWICPalette pIPalette, double alphaThresholdPercent, WICBitmapPaletteType paletteTranslate);
		HRESULT CanConvert(REFWICPixelFormatGUID srcPixelFormat, REFWICPixelFormatGUID dstPixelFormat, BOOL* pfCanConvert);
	}

	interface IWICBitmapScaler : IWICBitmapSource
	{
		HRESULT Initialize(IWICBitmapSource pISource, UINT uiWidth, UINT uiHeight, WICBitmapInterpolationMode mode);
	}

	interface IWICBitmapClipper : IWICBitmapSource
	{
		HRESULT Initialize(IWICBitmapSource pISource, const(WICRect)* prc);
	}

	interface IWICBitmapFlipRotator : IWICBitmapSource
	{
		HRESULT Initialize(IWICBitmapSource pISource, WICBitmapTransformOptions options);
	}


	interface IWICBitmapLock : IUnknown
	{
		HRESULT GetSize(UINT* puiWidth, UINT* puiHeight);
		HRESULT GetStride(UINT* pcbStride);
		HRESULT GetDataPointer(UINT* pcbBufferSize, BYTE** ppbData);
		HRESULT GetPixelFormat(WICPixelFormatGUID* pPixelFormat);
	}

	interface IWICBitmap : IWICBitmapSource
	{
		HRESULT Lock(const(WICRect)* prcLock, DWORD flags, IWICBitmapLock* ppILock);
		HRESULT SetPalette(IWICPalette pIPalette);
		HRESULT SetResolution(double dpiX, double dpiY);
	}

	interface IWICColorContext : IUnknown
	{
		HRESULT InitializeFromFilename(LPCWSTR wzFilename);
		HRESULT InitializeFromMemory(const(BYTE)* pbBuffer, UINT cbBufferSize);
		HRESULT InitializeFromExifColorSpace(UINT value);
		HRESULT GetType(WICColorContextType* pType);
		HRESULT GetProfileBytes(UINT cbBuffer, BYTE* pbBuffer, UINT* pcbActual);
		HRESULT GetExifColorSpace(UINT* pValue);
	}

	interface IWICColorTransform : IWICBitmapSource
	{
		HRESULT Initialize(IWICBitmapSource pIBitmapSource, IWICColorContext pIContextSource, IWICColorContext pIContextDest, REFWICPixelFormatGUID pixelFmtDest);
	}

	interface IWICFastMetadataEncoder : IUnknown
	{
		HRESULT Commit();
		HRESULT GetMetadataQueryWriter(IWICMetadataQueryWriter* ppIMetadataQueryWriter);
	}

	interface IWICStream : IStream
	{
		HRESULT InitializeFromIStream(IStream pIStream);
		HRESULT InitializeFromFilename(LPCWSTR wzFileName, DWORD dwDesiredAccess);
		HRESULT InitializeFromMemory(BYTE* pbBuffer, DWORD cbBufferSize);
		HRESULT InitializeFromIStreamRegion(IStream pIStream, ULARGE_INTEGER ulOffset, ULARGE_INTEGER ulMaxSize);
	}

	interface IWICEnumMetadataItem : IUnknown
	{
		HRESULT Next(ULONG celt, PROPVARIANT* rgeltSchema, PROPVARIANT* rgeltId, PROPVARIANT* rgeltValue, ULONG* pceltFetched);
		HRESULT Skip(ULONG celt);
		HRESULT Reset();
		HRESULT Clone(IWICEnumMetadataItem* ppIEnumMetadataItem);
	}

	interface IWICMetadataQueryReader : IUnknown
	{
		HRESULT GetContainerFormat(GUID* pguidContainerFormat);
		HRESULT GetLocation(UINT cchMaxLength, WCHAR* wzNamespace, UINT* pcchActualLength);
		HRESULT GetMetadataByName(LPCWSTR wzName, PROPVARIANT* pvarValue);
		HRESULT GetEnumerator(IEnumString* ppIEnumString);
	}

	interface IWICMetadataQueryWriter : IWICMetadataQueryReader
	{
		HRESULT SetMetadataByName(LPCWSTR wzName, const(PROPVARIANT)* pvarValue);
		HRESULT RemoveMetadataByName(LPCWSTR wzName);
	}

	interface IWICBitmapEncoder : IUnknown
	{
		HRESULT Initialize(IStream pIStream, WICBitmapEncoderCacheOption cacheOption);
		HRESULT GetContainerFormat(GUID* pguidContainerFormat);
		HRESULT GetEncoderInfo(IWICBitmapEncoderInfo* ppIEncoderInfo);
		HRESULT SetColorContexts(UINT cCount, IWICColorContext* ppIColorContext);
		HRESULT SetPalette(IWICPalette pIPalette);
		HRESULT SetThumbnail(IWICBitmapSource pIThumbnail);
		HRESULT SetPreview(IWICBitmapSource pIPreview);
		HRESULT CreateNewFrame(IWICBitmapFrameEncode* ppIFrameEncode, IPropertyBag2* ppIEncoderOptions);
		HRESULT Commit();
		HRESULT GetMetadataQueryWriter(IWICMetadataQueryWriter* ppIMetadataQueryWriter);
	}

	interface IWICBitmapFrameEncode : IUnknown
	{
		HRESULT Initialize(IPropertyBag2 pIEncoderOptions);
		HRESULT SetSize(UINT uiWidth, UINT uiHeight);
		HRESULT SetResolution(double dpiX, double dpiY);
		HRESULT SetPixelFormat(WICPixelFormatGUID* pPixelFormat);
		HRESULT SetColorContexts(UINT cCount, IWICColorContext* ppIColorContext);
		HRESULT SetPalette(IWICPalette pIPalette);
		HRESULT SetThumbnail(IWICBitmapSource pIThumbnail);
		HRESULT WritePixels(UINT lineCount, UINT cbStride, UINT cbBufferSize, BYTE* pbPixels);
		HRESULT WriteSource(IWICBitmapSource pIBitmapSource, WICRect* prc);
		HRESULT Commit();
		HRESULT GetMetadataQueryWriter(IWICMetadataQueryWriter* ppIMetadataQueryWriter);
	}


	interface IWICBitmapDecoder : IUnknown
	{
		HRESULT QueryCapability(IStream pIStream, DWORD* pdwCapability);
		HRESULT Initialize(IStream pIStream, WICDecodeOptions cacheOptions);
		HRESULT GetContainerFormat(GUID* pguidContainerFormat);
		HRESULT GetDecoderInfo(IWICBitmapDecoderInfo* ppIDecoderInfo);
		HRESULT CopyPalette(IWICPalette pIPalette);
		HRESULT GetMetadataQueryReader(IWICMetadataQueryReader* ppIMetadataQueryReader);
		HRESULT GetPreview(IWICBitmapSource* ppIBitmapSource);
		HRESULT GetColorContexts(UINT cCount, IWICColorContext* ppIColorContexts, UINT* pcActualCount);
		HRESULT GetThumbnail(IWICBitmapSource* ppIThumbnail);
		HRESULT GetFrameCount(UINT* pCount);
		HRESULT GetFrame(UINT index, IWICBitmapFrameDecode* ppIBitmapFrame);
	}

	interface IWICBitmapSourceTransform : IUnknown
	{
		HRESULT CopyPixels(const(WICRect)* prcSrc, UINT uiWidth, UINT uiHeight, WICPixelFormatGUID* pguidDstFormat, WICBitmapTransformOptions dstTransform, UINT nStride, UINT cbBufferSize, BYTE* pbBuffer);
		HRESULT GetClosestSize(UINT* puiWidth, UINT* puiHeight);
		HRESULT GetClosestPixelFormat(WICPixelFormatGUID* pguidDstFormat);
		HRESULT DoesSupportTransform(WICBitmapTransformOptions dstTransform, BOOL* pfIsSupported);
	}

	interface IWICBitmapFrameDecode : IWICBitmapSource
	{
		HRESULT GetMetadataQueryReader(IWICMetadataQueryReader* ppIMetadataQueryReader);
		HRESULT GetColorContexts(UINT cCount, IWICColorContext* ppIColorContexts, UINT* pcActualCount);
		HRESULT GetThumbnail(IWICBitmapSource* ppIThumbnail);
	}

	alias HRESULT function(LPVOID pvData, ULONG uFrameNum, WICProgressOperation operation, double dblProgress) PFNProgressNotification;

	interface IWICBitmapCodecProgressNotification : IUnknown
	{
		HRESULT RegisterProgressNotification(PFNProgressNotification pfnProgressNotification, LPVOID pvData, DWORD dwProgressFlags);
	}

	interface IWICComponentInfo : IUnknown
	{
		HRESULT GetComponentType(WICComponentType* pType);
		HRESULT GetCLSID(CLSID* pclsid);
		HRESULT GetSigningStatus(DWORD* pStatus);
		HRESULT GetAuthor(UINT cchAuthor, WCHAR* wzAuthor, UINT* pcchActual);
		HRESULT GetVendorGUID(GUID* pguidVendor);
		HRESULT GetVersion(UINT cchVersion, WCHAR* wzVersion, UINT* pcchActual);
		HRESULT GetSpecVersion(UINT cchSpecVersion, WCHAR* wzSpecVersion, UINT* pcchActual);
		HRESULT GetFriendlyName(UINT cchFriendlyName, WCHAR* wzFriendlyName, UINT* pcchActual);
	}

	interface IWICFormatConverterInfo : IWICComponentInfo
	{
		HRESULT GetPixelFormats(UINT cFormats, WICPixelFormatGUID* pPixelFormatGUIDs, UINT* pcActual);
		HRESULT CreateInstance(IWICFormatConverter* ppIConverter);
	}

	interface IWICBitmapCodecInfo : IWICComponentInfo
	{
		HRESULT GetContainerFormat(GUID* pguidContainerFormat);
		HRESULT GetPixelFormats(UINT cFormats, GUID* pguidPixelFormats, UINT* pcActual);
		HRESULT GetColorManagementVersion(UINT cchColorManagementVersion, WCHAR* wzColorManagementVersion, UINT* pcchActual);
		HRESULT GetDeviceManufacturer(UINT cchDeviceManufacturer, WCHAR* wzDeviceManufacturer, UINT* pcchActual);
		HRESULT GetDeviceModels(UINT cchDeviceModels, WCHAR* wzDeviceModels, UINT* pcchActual);
		HRESULT GetMimeTypes(UINT cchMimeTypes, WCHAR* wzMimeTypes, UINT* pcchActual);
		HRESULT GetFileExtensions(UINT cchFileExtensions, WCHAR* wzFileExtensions, UINT* pcchActual);
		HRESULT DoesSupportAnimation(BOOL* pfSupportAnimation);
		HRESULT DoesSupportChromakey(BOOL* pfSupportChromakey);
		HRESULT DoesSupportLossless(BOOL* pfSupportLossless);
		HRESULT DoesSupportMultiframe(BOOL* pfSupportMultiframe);
		HRESULT MatchesMimeType(LPCWSTR wzMimeType, BOOL* pfMatches);
	}

	interface IWICBitmapEncoderInfo : IWICBitmapCodecInfo
	{
		HRESULT CreateInstance(IWICBitmapEncoder* ppIBitmapEncoder);
	}

	interface IWICBitmapDecoderInfo : IWICBitmapCodecInfo
	{
		HRESULT GetPatterns(UINT cbSizePatterns, WICBitmapPattern* pPatterns, UINT* pcPatterns, UINT* pcbPatternsActual);
		HRESULT MatchesPattern(IStream pIStream, BOOL* pfMatches);
		HRESULT CreateInstance(IWICBitmapDecoder* ppIBitmapDecoder);
	}

	interface IWICPixelFormatInfo : IWICComponentInfo
	{
		HRESULT GetFormatGUID(GUID* pFormat);
		HRESULT GetColorContext(IWICColorContext* ppIColorContext);
		HRESULT GetBitsPerPixel(UINT* puiBitsPerPixel);
		HRESULT GetChannelCount(UINT* puiChannelCount);
		HRESULT GetChannelMask(UINT uiChannelIndex, UINT cbMaskBuffer, BYTE* pbMaskBuffer, UINT* pcbActual);
	}

	interface IWICImagingFactory : IUnknown
	{
		HRESULT CreateDecoderFromFilename(LPCWSTR wzFilename, const(GUID)* pguidVendor, DWORD dwDesiredAccess, WICDecodeOptions metadataOptions, IWICBitmapDecoder* ppIDecoder);
		HRESULT CreateDecoderFromStream(IStream pIStream, const(GUID)* pguidVendor, WICDecodeOptions metadataOptions, IWICBitmapDecoder* ppIDecoder);
		HRESULT CreateDecoderFromFileHandle(ULONG_PTR hFile, const(GUID)* pguidVendor, WICDecodeOptions metadataOptions, IWICBitmapDecoder* ppIDecoder);
		HRESULT CreateComponentInfo(REFCLSID clsidComponent, IWICComponentInfo* ppIInfo);
		HRESULT CreateDecoder(REFGUID guidContainerFormat, const(GUID)* pguidVendor, IWICBitmapDecoder* ppIDecoder);
		HRESULT CreateEncoder(REFGUID guidContainerFormat, const(GUID)* pguidVendor, IWICBitmapEncoder* ppIEncoder);
		HRESULT CreatePalette(IWICPalette* ppIPalette);
		HRESULT CreateFormatConverter(IWICFormatConverter* ppIFormatConverter);
		HRESULT CreateBitmapScaler(IWICBitmapScaler* ppIBitmapScaler);
		HRESULT CreateBitmapClipper(IWICBitmapClipper* ppIBitmapClipper);
		HRESULT CreateBitmapFlipRotator(IWICBitmapFlipRotator* ppIBitmapFlipRotator);
		HRESULT CreateStream(IWICStream* ppIWICStream);
		HRESULT CreateColorContext(IWICColorContext* ppIWICColorContext);
		HRESULT CreateColorTransformer(IWICColorTransform* ppIWICColorTransform);
		HRESULT CreateBitmap(UINT uiWidth, UINT uiHeight, REFWICPixelFormatGUID pixelFormat, WICBitmapCreateCacheOption option, IWICBitmap* ppIBitmap);
		HRESULT CreateBitmapFromSource(IWICBitmapSource pIBitmapSource, WICBitmapCreateCacheOption option, IWICBitmap* ppIBitmap);
		HRESULT CreateBitmapFromSourceRect(IWICBitmapSource pIBitmapSource, UINT x, UINT y, UINT width, UINT height, IWICBitmap* ppIBitmap);
		HRESULT CreateBitmapFromMemory(UINT uiWidth, UINT uiHeight, REFWICPixelFormatGUID pixelFormat, UINT cbStride, UINT cbBufferSize, BYTE* pbBuffer, IWICBitmap* ppIBitmap);
		HRESULT CreateBitmapFromHBITMAP(HBITMAP hBitmap, HPALETTE hPalette, WICBitmapAlphaChannelOption options, IWICBitmap* ppIBitmap);
		HRESULT CreateBitmapFromHICON(HICON hIcon, IWICBitmap* ppIBitmap);
		HRESULT CreateComponentEnumerator(DWORD componentTypes, DWORD options, IEnumUnknown* ppIEnumUnknown);
		HRESULT CreateFastMetadataEncoderFromDecoder(IWICBitmapDecoder pIDecoder, IWICFastMetadataEncoder* ppIFastEncoder);
		HRESULT CreateFastMetadataEncoderFromFrameDecode(IWICBitmapFrameDecode* pIFrameDecoder, IWICFastMetadataEncoder* ppIFastEncoder);
		HRESULT CreateQueryWriter(REFGUID guidMetadataFormat, const(GUID)* pguidVendor, IWICMetadataQueryWriter* ppIQueryWriter);
		HRESULT CreateQueryWriterFromReader(IWICMetadataQueryReader pIQueryReader, const(GUID)* pguidVendor, IWICMetadataQueryWriter* ppIQueryWriter);
	}
}


immutable ushort FACILITY_WINCODEC_ERR = 0x898;
immutable ushort WINCODEC_ERR_BASE = 0x2000;

template MAKE_WINCODECHR(ushort sev, ushort code)
{
	immutable HRESULT MAKE_WINCODECHR = MAKE_HRESULT!(sev, FACILITY_WINCODEC_ERR, WINCODEC_ERR_BASE + code);
}

template MAKE_WINCODECHR_ERR(ushort code)
{
	immutable HRESULT MAKE_WINCODECHR_ERR = MAKE_WINCODECHR!(1, code);
}

immutable HRESULT INTSAFE_E_ARITHMETIC_OVERFLOW = cast(HRESULT)0x80070216L; 

immutable HRESULT WINCODEC_ERR_GENERIC_ERROR                    = E_FAIL;
immutable HRESULT WINCODEC_ERR_INVALIDPARAMETER                 = E_INVALIDARG;
immutable HRESULT WINCODEC_ERR_OUTOFMEMORY                      = E_OUTOFMEMORY;
immutable HRESULT WINCODEC_ERR_NOTIMPLEMENTED                   = E_NOTIMPL;
immutable HRESULT WINCODEC_ERR_ABORTED                          = E_ABORT;
immutable HRESULT WINCODEC_ERR_ACCESSDENIED                     = E_ACCESSDENIED;
immutable HRESULT WINCODEC_ERR_VALUEOVERFLOW                    = INTSAFE_E_ARITHMETIC_OVERFLOW;
immutable HRESULT WINCODEC_ERR_WRONGSTATE                       = MAKE_WINCODECHR_ERR!(0xf04);
immutable HRESULT WINCODEC_ERR_VALUEOUTOFRANGE                  = MAKE_WINCODECHR_ERR!(0xf05);
immutable HRESULT WINCODEC_ERR_UNKNOWNIMAGEFORMAT               = MAKE_WINCODECHR_ERR!(0xf07);
immutable HRESULT WINCODEC_ERR_UNSUPPORTEDVERSION               = MAKE_WINCODECHR_ERR!(0xf0B);
immutable HRESULT WINCODEC_ERR_NOTINITIALIZED                   = MAKE_WINCODECHR_ERR!(0xf0C);
immutable HRESULT WINCODEC_ERR_ALREADYLOCKED                    = MAKE_WINCODECHR_ERR!(0xf0D);
immutable HRESULT WINCODEC_ERR_PROPERTYNOTFOUND                 = MAKE_WINCODECHR_ERR!(0xf40);
immutable HRESULT WINCODEC_ERR_PROPERTYNOTSUPPORTED             = MAKE_WINCODECHR_ERR!(0xf41);
immutable HRESULT WINCODEC_ERR_PROPERTYSIZE                     = MAKE_WINCODECHR_ERR!(0xf42);
immutable HRESULT WINCODEC_ERR_CODECPRESENT                     = MAKE_WINCODECHR_ERR!(0xf43);
immutable HRESULT WINCODEC_ERR_CODECNOTHUMBNAIL                 = MAKE_WINCODECHR_ERR!(0xf44);
immutable HRESULT WINCODEC_ERR_PALETTEUNAVAILABLE               = MAKE_WINCODECHR_ERR!(0xf45);
immutable HRESULT WINCODEC_ERR_CODECTOOMANYSCANLINES            = MAKE_WINCODECHR_ERR!(0xf46);
immutable HRESULT WINCODEC_ERR_INTERNALERROR                    = MAKE_WINCODECHR_ERR!(0xf48);
immutable HRESULT WINCODEC_ERR_SOURCERECTDOESNOTMATCHDIMENSIONS = MAKE_WINCODECHR_ERR!(0xf49);
immutable HRESULT WINCODEC_ERR_COMPONENTNOTFOUND                = MAKE_WINCODECHR_ERR!(0xf50);
immutable HRESULT WINCODEC_ERR_IMAGESIZEOUTOFRANGE              = MAKE_WINCODECHR_ERR!(0xf51);
immutable HRESULT WINCODEC_ERR_TOOMUCHMETADATA                  = MAKE_WINCODECHR_ERR!(0xf52);
immutable HRESULT WINCODEC_ERR_BADIMAGE                         = MAKE_WINCODECHR_ERR!(0xf60);
immutable HRESULT WINCODEC_ERR_BADHEADER                        = MAKE_WINCODECHR_ERR!(0xf61);
immutable HRESULT WINCODEC_ERR_FRAMEMISSING                     = MAKE_WINCODECHR_ERR!(0xf62);
immutable HRESULT WINCODEC_ERR_BADMETADATAHEADER                = MAKE_WINCODECHR_ERR!(0xf63);
immutable HRESULT WINCODEC_ERR_BADSTREAMDATA                    = MAKE_WINCODECHR_ERR!(0xf70);
immutable HRESULT WINCODEC_ERR_STREAMWRITE                      = MAKE_WINCODECHR_ERR!(0xf71);
immutable HRESULT WINCODEC_ERR_STREAMREAD                       = MAKE_WINCODECHR_ERR!(0xf72);
immutable HRESULT WINCODEC_ERR_STREAMNOTAVAILABLE               = MAKE_WINCODECHR_ERR!(0xf73);
immutable HRESULT WINCODEC_ERR_UNSUPPORTEDPIXELFORMAT           = MAKE_WINCODECHR_ERR!(0xf80);
immutable HRESULT WINCODEC_ERR_UNSUPPORTEDOPERATION             = MAKE_WINCODECHR_ERR!(0xf81);
immutable HRESULT WINCODEC_ERR_INVALIDREGISTRATION              = MAKE_WINCODECHR_ERR!(0xf8A);
immutable HRESULT WINCODEC_ERR_COMPONENTINITIALIZEFAILURE       = MAKE_WINCODECHR_ERR!(0xf8B);
immutable HRESULT WINCODEC_ERR_INSUFFICIENTBUFFER               = MAKE_WINCODECHR_ERR!(0xf8C);
immutable HRESULT WINCODEC_ERR_DUPLICATEMETADATAPRESENT         = MAKE_WINCODECHR_ERR!(0xf8D);
immutable HRESULT WINCODEC_ERR_PROPERTYUNEXPECTEDTYPE           = MAKE_WINCODECHR_ERR!(0xf8E);
immutable HRESULT WINCODEC_ERR_UNEXPECTEDSIZE                   = MAKE_WINCODECHR_ERR!(0xf8F);
immutable HRESULT WINCODEC_ERR_INVALIDQUERYREQUEST              = MAKE_WINCODECHR_ERR!(0xf90);
immutable HRESULT WINCODEC_ERR_UNEXPECTEDMETADATATYPE           = MAKE_WINCODECHR_ERR!(0xf91);
immutable HRESULT WINCODEC_ERR_REQUESTONLYVALIDATMETADATAROOT   = MAKE_WINCODECHR_ERR!(0xf92);
immutable HRESULT WINCODEC_ERR_INVALIDQUERYCHARACTER            = MAKE_WINCODECHR_ERR!(0xf93);

enum WICTiffCompressionOption
{
	WICTiffCompressionDontCare           = 0,
	WICTiffCompressionNone               = 0x1,
	WICTiffCompressionCCITT3             = 0x2,
	WICTiffCompressionCCITT4             = 0x3,
	WICTiffCompressionLZW                = 0x4,
	WICTiffCompressionRLE                = 0x5,
	WICTiffCompressionZIP                = 0x6,
	WICTIFFCOMPRESSIONOPTION_FORCE_DWORD = 0x7fffffff
}

enum WICNamedWhitePoint
{
	WICWhitePointDefault           = 0x1,
	WICWhitePointDaylight          = 0x2,
	WICWhitePointCloudy            = 0x4,
	WICWhitePointShade             = 0x8,
	WICWhitePointTungsten          = 0x10,
	WICWhitePointFluorescent       = 0x20,
	WICWhitePointFlash             = 0x40,
	WICWhitePointUnderwater        = 0x80,
	WICWhitePointCustom            = 0x100,
	WICWhitePointAutoWhiteBalance  = 0x200,
	WICWhitePointAsShot            = WICWhitePointDefault,
	WICNAMEDWHITEPOINT_FORCE_DWORD = 0x7fffffff
}

enum WICRawCapabilities
{
	WICRawCapabilityNotSupported   = 0,
	WICRawCapabilityGetSupported   = 0x1,
	WICRawCapabilityFullySupported = 0x2,
	WICRAWCAPABILITIES_FORCE_DWORD = 0x7fffffff
}

enum WICRawRotationCapabilities
{
	WICRawRotationCapabilityNotSupported           = 0,
	WICRawRotationCapabilityGetSupported           = 0x1,
	WICRawRotationCapabilityNinetyDegreesSupported = 0x2,
	WICRawRotationCapabilityFullySupported         = 0x3,
	WICRAWROTATIONCAPABILITIES_FORCE_DWORD         = 0x7fffffff
}

struct WICRawCapabilitiesInfo
{
	UINT cbSize;
	UINT CodecMajorVersion;
	UINT CodecMinorVersion;
	WICRawCapabilities ExposureCompensationSupport;
	WICRawCapabilities ContrastSupport;
	WICRawCapabilities RGBWhitePointSupport;
	WICRawCapabilities NamedWhitePointSupport;
	UINT NamedWhitePointSupportMask;
	WICRawCapabilities KelvinWhitePointSupport;
	WICRawCapabilities GammaSupport;
	WICRawCapabilities TintSupport;
	WICRawCapabilities SaturationSupport;
	WICRawCapabilities SharpnessSupport;
	WICRawCapabilities NoiseReductionSupport;
	WICRawCapabilities DestinationColorProfileSupport;
	WICRawCapabilities ToneCurveSupport;
	WICRawRotationCapabilities RotationSupport;
	WICRawCapabilities RenderModeSupport;
}

enum WICRawParameterSet
{
	WICAsShotParameterSet          = 0x1,
	WICUserAdjustedParameterSet    = 0x2,
	WICAutoAdjustedParameterSet    = 0x3,
	WICRAWPARAMETERSET_FORCE_DWORD = 0x7fffffff
}

enum WICRawRenderMode
{
	WICRawRenderModeDraft        = 0x1,
	WICRawRenderModeNormal       = 0x2,
	WICRawRenderModeBestQuality  = 0x3,
	WICRAWRENDERMODE_FORCE_DWORD = 0x7fffffff
}

struct WICRawToneCurvePoint
{
	double Input;
	double Output;
}

struct WICRawToneCurve
{
	UINT cPoints;
	WICRawToneCurvePoint[1] aPoints;
}

immutable uint WICRawChangeNotification_ExposureCompensation    = 0x00000001;
immutable uint WICRawChangeNotification_NamedWhitePoint         = 0x00000002;
immutable uint WICRawChangeNotification_KelvinWhitePoint        = 0x00000004;
immutable uint WICRawChangeNotification_RGBWhitePoint           = 0x00000008;
immutable uint WICRawChangeNotification_Contrast                = 0x00000010;
immutable uint WICRawChangeNotification_Gamma                   = 0x00000020;
immutable uint WICRawChangeNotification_Sharpness               = 0x00000040;
immutable uint WICRawChangeNotification_Saturation              = 0x00000080;
immutable uint WICRawChangeNotification_Tint                    = 0x00000100;
immutable uint WICRawChangeNotification_NoiseReduction          = 0x00000200;
immutable uint WICRawChangeNotification_DestinationColorContext = 0x00000400;
immutable uint WICRawChangeNotification_ToneCurve               = 0x00000800;
immutable uint WICRawChangeNotification_Rotation                = 0x00001000;
immutable uint WICRawChangeNotification_RenderMode              = 0x00002000;

extern (Windows)
{
	interface IWICDevelopRawNotificationCallback : IUnknown
	{
		HRESULT Notify(UINT NotificationMask);
	}

	interface IWICDevelopRaw : IWICBitmapFrameDecode
	{
		HRESULT QueryRawCapabilitiesInfo(WICRawCapabilitiesInfo* pInfo);
		HRESULT LoadParameterSet(WICRawParameterSet ParameterSet);
		HRESULT GetCurrentParameterSet(IPropertyBag2* ppCurrentParameterSet);
		HRESULT SetExposureCompensation(double ev);
		HRESULT GetExposureCompensation(double* pEV);
		HRESULT SetWhitePointRGB(UINT Red, UINT Green, UINT Blue);
		HRESULT GetWhitePointRGB(UINT* pRed, UINT* pGreen, UINT* pBlue);
		HRESULT SetNamedWhitePoint(WICNamedWhitePoint WhitePoint);
		HRESULT GetNamedWhitePoint(WICNamedWhitePoint* pWhitePoint);
		HRESULT SetWhitePointKelvin(UINT WhitePointKelvin);
		HRESULT GetWhitePointKelvin(UINT* pWhitePointKelvin);
		HRESULT GetKelvinRangeInfo(UINT* pMinKelvinTemp, UINT* pMaxKelvinTemp, UINT* pKelvinTempStepValue);
		HRESULT SetContrast(double Contrast);
		HRESULT GetContrast(double* pContrast);
		HRESULT SetGamma(double Gamma);
		HRESULT GetGamma(double* pGamma);
		HRESULT SetSharpness(double Sharpness);
		HRESULT GetSharpness(double* pSharpness);
		HRESULT SetSaturation(double Saturation);
		HRESULT GetSaturation(double* pSaturation);
		HRESULT SetTint(double Tint);
		HRESULT GetTint(double* pTint);
		HRESULT SetNoiseReduction(double NoiseReduction);
		HRESULT GetNoiseReduction(double* pNoiseReduction);
		HRESULT SetDestinationColorContext(const(IWICColorContext) pColorContext);
		HRESULT SetToneCurve(UINT cbToneCurveSize, const(WICRawToneCurve)* pToneCurve);
		HRESULT GetToneCurve(UINT cbToneCurveBufferSize, WICRawToneCurve* pToneCurve, UINT* pcbActualToneCurveBufferSize);
		HRESULT SetRotation(double Rotation);
		HRESULT GetRotation(double* pRotation);
		HRESULT SetRenderMode(WICRawRenderMode RenderMode);
		HRESULT GetRenderMode(WICRawRenderMode* pRenderMode);
		HRESULT SetNotificationCallback(IWICDevelopRawNotificationCallback* pCallback);
	}
}

